import { parseTime } from './ruoyi'

/**
 * 表格时间格式化
 */
export function formatDate(cellValue) {
  if (cellValue == null || cellValue == "") return ""
  var date = new Date(cellValue)
  var year = date.getFullYear()
  var month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1
  var day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate()
  var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours()
  var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()
  var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds()
  return year + '-' + month + '-' + day + ' ' + hours + ':' + minutes + ':' + seconds
}

/**
 * @param {number} time
 * @param {string} option
 * @returns {string}
 */
export function formatTime(time, option) {
  if (('' + time).length === 10) {
    time = parseInt(time) * 1000
  } else {
    time = +time
  }
  const d = new Date(time)
  const now = Date.now()

  const diff = (now - d) / 1000

  if (diff < 30) {
    return '刚刚'
  } else if (diff < 3600) {
    // less 1 hour
    return Math.ceil(diff / 60) + '分钟前'
  } else if (diff < 3600 * 24) {
    return Math.ceil(diff / 3600) + '小时前'
  } else if (diff < 3600 * 24 * 2) {
    return '1天前'
  }
  if (option) {
    return parseTime(time, option)
  } else {
    return (
      d.getMonth() +
      1 +
      '月' +
      d.getDate() +
      '日' +
      d.getHours() +
      '时' +
      d.getMinutes() +
      '分'
    )
  }
}

/**
 * @param {string} url
 * @returns {Object}
 */
export function getQueryObject(url) {
  url = url == null ? window.location.href : url
  const search = url.substring(url.lastIndexOf('?') + 1)
  const obj = {}
  const reg = /([^?&=]+)=([^?&=]*)/g
  search.replace(reg, (rs, $1, $2) => {
    const name = decodeURIComponent($1)
    let val = decodeURIComponent($2)
    val = String(val)
    obj[name] = val
    return rs
  })
  return obj
}

/**
 * @param {string} input value
 * @returns {number} output value
 */
export function byteLength(str) {
  // returns the byte length of an utf8 string
  let s = str.length
  for (var i = str.length - 1; i >= 0; i--) {
    const code = str.charCodeAt(i)
    if (code > 0x7f && code <= 0x7ff) s++
    else if (code > 0x7ff && code <= 0xffff) s += 2
    if (code >= 0xDC00 && code <= 0xDFFF) i--
  }
  return s
}

/**
 * @param {Array} actual
 * @returns {Array}
 */
export function cleanArray(actual) {
  const newArray = []
  for (let i = 0; i < actual.length; i++) {
    if (actual[i]) {
      newArray.push(actual[i])
    }
  }
  return newArray
}

/**
 * @param {Object} json
 * @returns {Array}
 */
export function param(json) {
  if (!json) return ''
  return cleanArray(
    Object.keys(json).map(key => {
      if (json[key] === undefined) return ''
      return encodeURIComponent(key) + '=' + encodeURIComponent(json[key])
    })
  ).join('&')
}

/**
 * @param {string} url
 * @returns {Object}
 */
export function param2Obj(url) {
  const search = decodeURIComponent(url.split('?')[1]).replace(/\+/g, ' ')
  if (!search) {
    return {}
  }
  const obj = {}
  const searchArr = search.split('&')
  searchArr.forEach(v => {
    const index = v.indexOf('=')
    if (index !== -1) {
      const name = v.substring(0, index)
      const val = v.substring(index + 1, v.length)
      obj[name] = val
    }
  })
  return obj
}

/**
 * @param {string} val
 * @returns {string}
 */
export function html2Text(val) {
  const div = document.createElement('div')
  div.innerHTML = val
  return div.textContent || div.innerText
}

/**
 * Merges two objects, giving the last one precedence
 * @param {Object} target
 * @param {(Object|Array)} source
 * @returns {Object}
 */
export function objectMerge(target, source) {
  if (typeof target !== 'object') {
    target = {}
  }
  if (Array.isArray(source)) {
    return source.slice()
  }
  Object.keys(source).forEach(property => {
    const sourceProperty = source[property]
    if (typeof sourceProperty === 'object') {
      target[property] = objectMerge(target[property], sourceProperty)
    } else {
      target[property] = sourceProperty
    }
  })
  return target
}

/**
 * @param {HTMLElement} element
 * @param {string} className
 */
export function toggleClass(element, className) {
  if (!element || !className) {
    return
  }
  let classString = element.className
  const nameIndex = classString.indexOf(className)
  if (nameIndex === -1) {
    classString += '' + className
  } else {
    classString =
      classString.substr(0, nameIndex) +
      classString.substr(nameIndex + className.length)
  }
  element.className = classString
}

/**
 * @param {string} type
 * @returns {Date}
 */
export function getTime(type) {
  if (type === 'start') {
    return new Date().getTime() - 3600 * 1000 * 24 * 90
  } else {
    return new Date(new Date().toDateString())
  }
}

/**
 * @param {Function} func
 * @param {number} wait
 * @param {boolean} immediate
 * @return {*}
 */
export function debounce(func, wait, immediate) {
  let timeout, args, context, timestamp, result

  const later = function() {
    // 据上一次触发时间间隔
    const last = +new Date() - timestamp

    // 上次被包装函数被调用时间间隔 last 小于设定时间间隔 wait
    if (last < wait && last > 0) {
      timeout = setTimeout(later, wait - last)
    } else {
      timeout = null
      // 如果设定为immediate===true，因为开始边界已经调用过了此处无需调用
      if (!immediate) {
        result = func.apply(context, args)
        if (!timeout) context = args = null
      }
    }
  }

  return function(...args) {
    context = this
    timestamp = +new Date()
    const callNow = immediate && !timeout
    // 如果延时不存在，重新设定延时
    if (!timeout) timeout = setTimeout(later, wait)
    if (callNow) {
      result = func.apply(context, args)
      context = args = null
    }

    return result
  }
}

/**
 * This is just a simple version of deep copy
 * Has a lot of edge cases bug
 * If you want to use a perfect deep copy, use lodash's _.cloneDeep
 * @param {Object} source
 * @returns {Object}
 */
export function deepClone(source) {
  if (!source && typeof source !== 'object') {
    throw new Error('error arguments', 'deepClone')
  }
  const targetObj = source.constructor === Array ? [] : {}
  Object.keys(source).forEach(keys => {
    if (source[keys] && typeof source[keys] === 'object') {
      targetObj[keys] = deepClone(source[keys])
    } else {
      targetObj[keys] = source[keys]
    }
  })
  return targetObj
}

/**
 * @param {Array} arr
 * @returns {Array}
 */
export function uniqueArr(arr) {
  return Array.from(new Set(arr))
}

/**
 * @returns {string}
 */
export function createUniqueString() {
  const timestamp = +new Date() + ''
  const randomNum = parseInt((1 + Math.random()) * 65536) + ''
  return (+(randomNum + timestamp)).toString(32)
}

/**
 * Check if an element has a class
 * @param {HTMLElement} elm
 * @param {string} cls
 * @returns {boolean}
 */
export function hasClass(ele, cls) {
  return !!ele.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'))
}

/**
 * Add class to element
 * @param {HTMLElement} elm
 * @param {string} cls
 */
export function addClass(ele, cls) {
  if (!hasClass(ele, cls)) ele.className += ' ' + cls
}

/**
 * Remove class from element
 * @param {HTMLElement} elm
 * @param {string} cls
 */
export function removeClass(ele, cls) {
  if (hasClass(ele, cls)) {
    const reg = new RegExp('(\\s|^)' + cls + '(\\s|$)')
    ele.className = ele.className.replace(reg, ' ')
  }
}

export function makeMap(str, expectsLowerCase) {
  const map = Object.create(null)
  const list = str.split(',')
  for (let i = 0; i < list.length; i++) {
    map[list[i]] = true
  }
  return expectsLowerCase
    ? val => map[val.toLowerCase()]
    : val => map[val]
}

export const exportDefault = 'export default '

export const beautifierConf = {
  html: {
    indent_size: '2',
    indent_char: ' ',
    max_preserve_newlines: '-1',
    preserve_newlines: false,
    keep_array_indentation: false,
    break_chained_methods: false,
    indent_scripts: 'separate',
    brace_style: 'end-expand',
    space_before_conditional: true,
    unescape_strings: false,
    jslint_happy: false,
    end_with_newline: true,
    wrap_line_length: '110',
    indent_inner_html: true,
    comma_first: false,
    e4x: true,
    indent_empty_lines: true
  },
  js: {
    indent_size: '2',
    indent_char: ' ',
    max_preserve_newlines: '-1',
    preserve_newlines: false,
    keep_array_indentation: false,
    break_chained_methods: false,
    indent_scripts: 'normal',
    brace_style: 'end-expand',
    space_before_conditional: true,
    unescape_strings: false,
    jslint_happy: true,
    end_with_newline: true,
    wrap_line_length: '110',
    indent_inner_html: true,
    comma_first: false,
    e4x: true,
    indent_empty_lines: true
  }
}

// 首字母大小
export function titleCase(str) {
  return str.replace(/( |^)[a-z]/g, L => L.toUpperCase())
}

// 下划转驼峰
export function camelCase(str) {
  return str.replace(/_[a-z]/g, str1 => str1.substr(-1).toUpperCase())
}

export function isNumberStr(str) {
  return /^[+-]?(0|([1-9]\d*))(\.\d+)?$/g.test(str)
}

export function save(name, src) {
  let a = 0;
  let url = null;
  try
  {
    url = window.URL.createObjectURL(new Blob([src]))
    a = document.createElement('a');
    document.body.append(a);
    a.style.display = 'none'
    a.href = url;
    a.setAttribute('download', name)
    a.click();
    return true;
  }
  catch(e)
  {
    console.error(e);
    return false;
  }
  finally
  {
    if(a)
      a.remove();
    if(url)
      window.URL.revokeObjectURL(url);
  }
}

/**
 * 解析日期时间
 * @param date 日期时间字符串 字符串
 * @param format 格式化字符串 字符串 默认 yyyy-MM-dd HH:mm:ss
 * @param initNow 缺省部分是否使用当前日期时间部分代替 bool 默认不使用当前
 * @returns {Date} 解析日期时间出来的Date对象
 */
export function strtotime(date, format, initNow)
{
  if (!date)
    return null;
  let expect = function(target, str) {
    if(Array.isArray(target))
    {
      let res = 0;
      if(typeof(target[0]) === 'number')
      {
        for(let t of target)
        {
          if(str.length >= t)
          {
            if(t > res && new RegExp(`^\\d{${t}}`).test(str))
              res = t;
          }
        }
      }
      else
      {
        for(let t of target)
        {
          if(str.length < t.length)
            continue;
          if(str.startsWith(t))
          {
            res = t.length;
            break;
          }
        }
      }
      return res;
    }
    else
    {
      if(typeof(target) === 'number')
      {
        if(str.length < target)
          return 0;
        if(!new RegExp(`^\\d{${target}}`).test(str))
          return null;
        return target;
      }
      else if(typeof(target) === 'object')
      {
        let res = 0;
        let min = target.min || 0;
        let max = target.max;
        for(let m = min; m <= max; m++)
        {
          let t = '' + m;
          if(str.length >= t.length)
          {
            if(str.startsWith(t))
              res = t.length;
          }
        }
        return res;
      }
      else
      {
        if(str.length < target.length)
          return 0;
        if(!str.startsWith(target))
          return 0;
        return target.length;
      }
    }
  };
  format = format || 'yyyy-MM-dd HH:mm:ss';
  let arr = parseDateTimeFormatter(format);
  let i = 0;
  let _y = undefined;
  let _m = undefined;
  let _d = undefined;
  let _h = undefined;
  let _i = undefined;
  let _s = undefined;
  let _z = undefined;
  let _h_12 = undefined;
  let _ap = undefined;
  let get_token = function(str, target) {
    let r = expect(target, date.substr(i));
    if(r <= 0)
      return null;
    let nstr = date.substr(i, r);
    i += r;
    return nstr;
  };
  //console.log(arr);
  for(let part of arr)
  {
    if(part.type === DATE_TIME_FORMAT_TYPE_RAW || part.type === DATE_TIME_FORMAT_TYPE_IGNORE)
    {
      let r = expect(part.str, date.substr(i));
      if(!r)
        return null;
      i += r;
    }
    else
    {
      let p = null;
      switch(part.str)
      {
        case 'yyyy':
        case '%Y':
          p = get_token(part.str, 4);
          if(p)
            _y = parseInt(p);
          break;
        case 'yy':
        case '%y':
          p = get_token(part.str, 2);
          if(p)
            _y = Math.floor((date.getFullYear()) / 100) * 100 + parseInt(p);
          break;
        case 'MM':
        case '%m':
          p = get_token(part.str, 2);
          if(p)
            _m = parseInt(p);
          break;
        case 'M':
        case '%c':
          p = get_token(part.str, {min: 1, max: 12});
          if(p)
            _m = parseInt(p);
          break;
        case 'MMMM':
        case '%M':
          p = get_token(part.str, MONTHS);
          if(p)
            _m = MONTHS.indexOf(p) + 1;
          break;
        case 'MMM':
        case '%b':
          p = get_token(part.str, MONTHS_SIMPLE);
          if(p)
            _m = MONTHS_SIMPLE.indexOf(p) + 1;
          break;
        case 'dd':
        case '%d':
          p = get_token(part.str, 2);
          if(p)
            _d = parseInt(p);
          break;
        case 'HH':
        case '%H':
          p = get_token(part.str, 2);
          if(p)
            _h = parseInt(p);
          break;
        case 'H':
        case '%k':
          p = get_token(part.str, {max: 23});
          if(p)
            _h = parseInt(p);
          break;
        case 'hh':
        case '%I':
        case '%h':
          p = get_token(part.str, 2);
          if(p)
            _h_12 = parseInt(p);
          break;
        case 'h':
        case '%l':
          p = get_token(part.str, {max: 12});
          if(p)
            _h_12 = parseInt(p);
          break;
        case 'mm':
        case 'ii':
        case '%i':
          p = get_token(part.str, 2);
          if(p)
            _i = parseInt(p);
          break;
        case 'm':
        case 'i':
          p = get_token(part.str, {max: 59});
          if(p)
            _i = parseInt(p);
          break;
        case 'ss':
        case '%s':
        case '%S':
          p = get_token(part.str, 2);
          if(p)
            _s = parseInt(p);
          break;
        case 's':
          p = get_token(part.str, {max: 59});
          if(p)
            _s = parseInt(p);
          break;
        case 'sss':
          p = get_token(part.str, {max: 999});
          if(p)
            _z = parseInt(p);
          break;
        case 'A':
        case 'p': {
          const AP = ['AM', 'PM'];
          p = get_token(part.str, AP);
          if(p)
            _ap = p.toLowerCase();
        }
          break;
        case 'a':
        case 'P':
        case '%p':{
          const AP = ['am', 'pm'];
          p = get_token(part.str, AP);
          if(p)
            _ap = p;
        }
          break;
        case 'u':
        case '%w':
        case '%W':
        case 'dddd':
        case 'ddd':
          throw new Error('不支持星期几解析: ' + part.str); // not ignore and throw
        //break;
        case '%%':
          //TODO: ignore 最好不解析出来
          break;
        default:
          throw new Error('不支持的格式解析: ' + part.str);
          break;
      }
      if(!p)
        return null;
    }
  }
  if(_h_12 !== undefined && _ap !== undefined)
  {
    _h = (_ap === 'pm' ? _h_12 + 12 : _h_12) % 24;
  }
  let res = new Date;
  //console.log('1111111111',_y, _m, _d, _h, _i, _s, _z);
  if(_y === undefined) _y = initNow ? res.getFullYear() : 0;
  if(_m === undefined) _m = initNow ? res.getMonth() + 1 : 1;
  if(_d === undefined) _d = initNow ? res.getDate() : 1;
  if(_h === undefined) _h = initNow ? res.getHours() : 0;
  if(_i === undefined) _i = initNow ? res.getMinutes() : 0;
  if(_s === undefined) _s = initNow ? res.getSeconds() : 0;
  if(_z === undefined) _z = initNow ? res.getMilliseconds() : 0;
  //console.log('2222222222',_y, _m, _d, _h, _i, _s, _z);
  res.setFullYear(_y, _m - 1, _d);
  res.setHours(_h, _i, _s, _z);
  return res;
}
